#ifndef _CHANNEL4_H_
#define _CHANNEL4_H_

// Basisklasse einbinden
#include "Channel4ModuleTable.h"

/*
#define ICMP_ECHO       8 
#define ICMP_ECHOREPLY  0 

#define ICMP_MIN        8 // minimum 8 byte icmp packet (just header) 

#define DEF_PACKET_SIZE 32 

// The IP header 
typedef struct iphdr {
	unsigned int h_len:4;          // length of the header
	unsigned int version:4;        // Version of IP
	unsigned char tos;             // Type of service
	unsigned short total_len;      // total length of the packet
	unsigned short ident;          // unique identifier
	unsigned short frag_and_flags; // flags
	unsigned char  ttl;
	unsigned char proto;           // protocol (TCP, UDP etc)
	unsigned short checksum;       // IP checksum

	unsigned int sourceIP;
	unsigned int destIP;
} IpHeader;

//
// ICMP header
//
typedef struct _ihdr {
	BYTE i_type;
	BYTE i_code; // type sub code 
	USHORT i_cksum;
	USHORT i_id;
	USHORT i_seq;
	// This is not the std header, but we reserve space for time 
	ULONG timestamp;
} IcmpHeader;
*/

class CNotifyRecord 
{
public:
	CNotifyRecord() {
		type = 0;
		priority = 0;
		deviceType = 0;
		serialNum = 0;
		commType = 0;
		memset(commString, 0, sizeof(commString));
		commValue = 0;
		deviceIDRemote = 0;
		memset(timestamp, 0, sizeof(timestamp));
		dt = 0;
	}

public:
	unsigned char type; // Meldungstyp
	short priority;     // Prioritaet des Geraetes
	unsigned char deviceType; // Geraetetyp
	unsigned long serialNum;  // Geraeteseriennummer
	unsigned char commType; // Kommunikationstyp: RS232(1), TCPIP(3)
	char *commString[64];   // Bei RS232 COM?, bei TCP/IP die Adresse
	int commValue;          // Bei RS232 die Baudrate, bei TCP/IP die Portnummer
	short deviceIDRemote;   // DeviceID des Geraets
	char timestamp[24];     // Zeitstempel der Meldungserzeugung (Format: "YYYY-MM-DD hh:mm:ss:mis")
	time_t dt;      // Zeitstempel der Annahme

public:
	bool operator < (const CNotifyRecord &other) const
	{
		return (priority < other.priority);
	}
};

class CChannel4 : public CChannel4ModuleTable
{
public:
	CChannel4() : CChannel4ModuleTable(IV_DEFAULT_CHANNELID, IV_DEFAULT_DEVICEID)
	{ InitClass(); }
	CChannel4(short channelID, short deviceID) : CChannel4ModuleTable(channelID, deviceID) 
	{ InitClass(channelID, deviceID); }
	virtual void InitClass(short channelID = IV_DEFAULT_CHANNELID, short deviceID = IV_DEFAULT_DEVICEID);
	virtual ~CChannel4();

#ifdef WIN32
	// Setzt Klassenzustand auf "in Verwendung"
	inline void SetBusy(int state) { m_busyState = state; }
	// Prueft ob Klasse bereits "in Verwendung"
	inline int IsBusy() { return m_busyState; }

	// Verbindungsannahme von uebergebenem Listen-Socket
	int Connect(SOCKET *listenSocket, short channelID, short deviceID = IV_DEFAULT_DEVICEID);
	// Endesignal im Workerthread setzen und auf dessen Beendigung warten
	void DirectClose();

	// Setzen der CallBack-Funktion fuer Datensatzbenachrichtigung
	void SetCBNotifyRecord(int (*CBNotifyRecord)(CNotifyRecord&))
	{
		m_CBNotifyRecord = CBNotifyRecord;
	}

// Main - Funktion fuer Befehlsausfuehrung in Workerthread
protected:
	static unsigned long WINAPI ConnectThread(LPVOID lpParam);
	volatile int m_endSignal;
	volatile int m_busyState;
	HANDLE m_connectThread;
	// Socket fuer Connect
	SOCKET *m_listenSocket, m_connectSocket;
	int (*m_CBNotifyRecord)(CNotifyRecord&);

	//#################################
	// CallRoutinen fuer die Abarbeitung anstehender Kommunikationsbefehle
//	virtual int CallFunction(short module, short function, unsigned char *data, int &count);
	// NotifyRoutine fuer die Abarbeitung von Benachrichtigungen unter den Klassen
	virtual int CallFunctionNotify(short module, short function, unsigned char *data, int &count);

/*
protected:
	char icmp_data[IV_PACKET_LENGTH_MAX];
	char recvbuf[IV_PACKET_LENGTH_MAX];

public:
	int PingICMP(char *remote);
	int BroadcastXPort(char *address_net);
	int CmdXPort(char *remote, char *data, unsigned short &count, int needAnswer = TRUE);
	void PreparePacket(char * icmp_data, int datasize);
	void CheckPacket(char *buf, int bytes, struct sockaddr_in *from);
	unsigned short Checksum(unsigned short *buffer, int size);
*/
#endif
};

#endif
